\documentclass{article}
\usepackage{hyperref}
\usepackage[linguistics]{forest}
\usepackage{graphicx}
\usepackage[margin=1in]{geometry}
\usepackage{adjustbox}

\title{Programming Assignment \#1: Regression Trees for Carseat Sales}
\author{John Karasev}
\date{May 18, 2018}


\begin{document}
\maketitle


\section{Summary}
For this assignment a regression tree was designed in python to predict car-seat sales
given a few features such as shelve location and average income of people in
the area. I used a single tree, a single pruned tree, bagged trees, and
random forests. The data-set can be found here
\url{https://www.kaggle.com/c/carseat-sales/data}

\section{Preprocessing}
All features that were not strings where standardized (re-scaled 0-1). I gave the
train set 80\% of the data and 20\% for the test. If I gave more data to the test
set, the tree would have not trained well since there is not a lot of data overall.

\section{Single Tree}
The single tree performed amazingly well with 0.021 average squared error
(remember the data is standardized).
Stop condition was 5 points in leafs.

\begin{forest}
    [${ShelveLoc=Good}$
    	[${Price >= 0.576}$
		[${Age >= 0.625}$
			[$leaf$]
			[${Price >= 0.471}$
				[$leaf$]
				[$leaf$]
			]
		]
		[${ShelveLoc==Bad}$
			[${Age >= 0.6}$
				[$leaf$]
				[${Price >= 0.723}$
					[$leaf$]
					[$leaf$]
				]
			]
			[$leaf$]
		]
	]
	[${Price >= 0.565}$
		[$leaf$]
		[$leaf$]
	]
    ]
\end{forest}

\pagebreak
\noindent Above is the tree that was generated during training. It looks like ShelveLoc is an
important feature since it is on the top.

\section{Single Pruned Tree}
For pruning the following cost function was used:
\[MSE + \alpha|T|\]
Using a 10 fold cross validation with one fold left for testing, many alpha values where tested and
$\alpha=2$ looked like the best choice. I tried the 10-fold cv many times on different alpha values.
Below is a plot that summarizes the results.
\vspace{2cm}

\adjustbox{valign=t}{\includegraphics[width=15cm]{./figures/kfold.jpeg}}

\pagebreak
\noindent Even though $\alpha=2$ had a good test error on the 10th fold, it performed
bad on the actual test set with $MSE = 0.039$. So I tested different alpha values
on the actual test set and got much better results. It turns out that when
$\alpha=6.95\cdot10^{-5}$, $MSE = 0.0176$. This is better than the single unpruned tree.
Note that 14 random branches where chosen to try all
possible prune combinations, the alpha might change for different branches.
A stable alpha value is $\alpha=7\cdot10^{-5}$,
it does not oscillate between different pruned branches. The second time the tree
was pruned on $\alpha=6.95\cdot10^{-5}$ a high MSE was calculated. $\alpha=7\cdot10^{-5}$
stayed consistent with $MSE$ around $0.0177$.
Below is a plot that summerizes actual test errors for different alpha values.
\vspace{2cm}

\adjustbox{valign=t}{\includegraphics[width=15cm]{./figures/actual.jpeg}}

\pagebreak
\section{Bagging}
I used 100 trees on different bootstrap samples of the train set and averaged
predictions for the test set. Bagging got an $MSE$ of $0.0149$.

\section{Mutual Information}
I think that mutual information is an accurate measure for determining which
features contribute to the "Sales" the most because it measures how similiar the probability
distrubutions are. Sklearn ml library was used to find mutual information on "Sales" vs. all other features.
Sklearn uses a mutual estimation method designed by A. Kraskov, H. Stogbauer and P. Grassberger.
Below are the results summarized in a table.

\begin{tabular}[t]{| l | r | }
	\hline
	\textbf{Feature} & \textbf{Mut. Inf.} \\ \hline
	CompPrice & 0 \\ \hline
	Income & 0.03726748 \\ \hline
	Advertising & 0.00974529 \\ \hline
	Population & 0 \\ \hline
	Price & 0.08449095 \\ \hline
	ShelveLoc & 0.20036151  \\ \hline
	Age & 0.04892523  \\ \hline
	Education & 0.05730954 \\ \hline
	Urban & 0 \\ \hline
	US & 0.03789112 \\
	\hline
\end{tabular}
\vspace{.5cm}

\noindent As seen in the single unpruned tree, "ShelveLoc" has the highest mutual information
with the "Sales". Next comes, in order, Price, Education, Age, US, Income, and then Advertising.
It can also be seen that "Price" and "Age" appear in many decisions in the tree diagram.
The mutual information of them explains why this happens.

\section{Random Forest}

I also used 100 trees for the random forest. Below is a plot that summerizes the error for
different $m$ (number of features) values.

\vspace{.25cm}

\adjustbox{valign=t}{\includegraphics[width=13cm]{./figures/forestbad.jpeg}}

\pagebreak
\noindent As more features where added to a sample, error decreased. $m=10$ had the smallest error of $MSE=.0185$.
The error is not a parabola curve where the error rises when a large feature sample is used.
I think this is because some variable have a mutual information of 0 and
that gives bad predictions for low feature samples.
By examining a couple of trees in the forest, it looked like the variables that had high
mutual information appeared the most in branch splits, a lot of trees had ShelveLoc on the roots.
ShelvLoc effects Sales the most and Price on the second place because they appeared the most
in the trees examined.



\end{document}
